// Subprogram.java
//
// ICS 142 Winter 2004
// Assignment #3
//
// Subprogram objects represent subprograms declared in Monkie2004 programs.
// They contain two things: an ArrayList of Type objects for the formal
// parameters, and a return Type (which will be null if there is no return
// type).
//
// THIS CLASS SHOULD BE LEFT AS-IS!


import java.util.*;


public class Subprogram extends SymbolTableEntry
{
	private ArrayList parameterTypeList;
	private Type returnType;
	private boolean function;


	public Subprogram(
		String identifier, ArrayList parameterTypeList,
		boolean isFunction, Type returnType)
	{
		super(identifier);
		this.parameterTypeList = parameterTypeList;
		this.function = isFunction;
		this.returnType = returnType;
	}


	public ArrayList getParameterTypeList()
	{
		return parameterTypeList;
	}


	public boolean isProcedure()
	{
		return !function;
	}


	public boolean isFunction()
	{
		return function;
	}


	public Type getReturnType()
	{
		return returnType;
	}
}
